=== debian/changelog ===
benchmark (1.9.5-1~exp1) experimental; urgency=medium

  * [bda5804] chore(debian): Bump library SONAME to 1.9.5
  * [9ddbab9] New upstream version 1.9.5
  * [a2e0c5e] chore(debian): Refresh existing patches
  * [f0127a6] chore: Update Standards-Version to 4.7.3
  * [47e67b0] chore(gitlab-ci): Switch to debian.yml recipe and enable license checks

 -- Anton Gladky <gladk@debian.org>  Thu, 22 Jan 2026 07:02:56 +0100
