=== debian/control ===
Source: benchmark
Standards-Version: 4.7.3
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Anton Gladky <gladk@debian.org>,
 Michael R. Crusoe <crusoe@debian.org>,
Section: libs
Priority: optional
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-python,
 libgmock-dev,
 python3-setuptools,
Vcs-Browser: https://salsa.debian.org/science-team/benchmark
Vcs-Git: https://salsa.debian.org/science-team/benchmark.git
Homepage: https://github.com/google/benchmark
Rules-Requires-Root: no

Package: libbenchmark-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 libbenchmark1.9.5 (= ${binary:Version}),
 ${misc:Depends},
Description: Microbenchmark support library, development files
 Library to support the benchmarking of functions, similar to unit-tests.
 .
 This package contains the development files.

Package: libbenchmark1.9.5
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 libbenchmark-tools,
Pre-Depends:
 ${misc:Pre-Depends},
Description: Microbenchmark support library, shared library
 Library to support the benchmarking of functions, similar to unit-tests.
 .
 This package contains the shared library.

Package: libbenchmark-tools
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 python3:any,
Pre-Depends:
 ${misc:Pre-Depends},
Description: Microbenchmark support library, tools and documentation
 Library to support the benchmarking of functions, similar to unit-tests.
 .
 This package contains tools and documentation.
